﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Markup;

namespace SLDataTemplate
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Button btn=sender as Button;
            //获取父级StackPanel
            StackPanel spParent1 = VisualTreeHelper.GetParent(btn) as StackPanel;
            //通过名字找到当前Item列的tbName元素
            TextBox tb = spParent1.FindName("tbName") as TextBox;
            tb.Text = tb.Text + "点击";
            //获得祖父级StackPanel
            StackPanel spParent2 = VisualTreeHelper.GetParent(spParent1) as StackPanel;
            //获取到其子元素
            StackPanel hidPanel = VisualTreeHelper.GetChild(spParent2, 1) as StackPanel;
            //设置动作
            btn.Content = btn.Content.ToString() == "展开" ? "隐藏" : "展开";
            hidPanel.Visibility =
                hidPanel.Visibility == Visibility.Visible ? Visibility.Collapsed : Visibility.Visible;
        }

        private void btnShow_Click(object sender, RoutedEventArgs e)
        {
            Button btn = sender as Button;
            //1.在这里必须是直接在ListBox.ItemTemplate下写的DataTemplate才能使用此LoadContent()方法
            //2.如果是使用ItemTemplate="{StaticResource lbTmp}"的方式则无法获取
            //3.此种方式获取到的是模板中初始情况的控件名单。而非当前列的控件名单
            StackPanel panel = (StackPanel)this.lbTempName.LoadContent();
            StackPanel hidPanel = VisualTreeHelper.GetChild(panel, 1) as StackPanel;

            //设置动作无法成功并且反馈到界面
            hidPanel.Visibility =
                hidPanel.Visibility == Visibility.Visible ? Visibility.Collapsed : Visibility.Visible;
        }
    }
}
